#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef USE_NLLIBC
#include <nllibc.h>
#endif

#include "config.h"
#include "types.h"
#include "nlllib.h"
#include "value.h"
#include "array.h"

static struct array arrays[ARRAY_MAXNUM];
static int array_num = 0;

int array_check(void)
{
  if (array_num)
    return NLL_ERRCODE_ARRAY_NOT_EMPTY;

  return 0;
}

int array_init(void)
{
  memset(arrays, 0, sizeof(arrays));
  array_num = 0;
  return 0;
}

int array_get(array_t *arrayp, int number)
{
  array_t array;
  int r, i;

  if (array_num + number > ARRAY_MAXNUM)
    return NLL_ERRCODE_ARRAY_BUFFER_OVER;

  array = &arrays[array_num];
  memset(array, 0, sizeof(*array) * number);

  for (i = 0; i < number; i++) {
    if ((r = value_alloc(&array[i].value)) < 0) {
      array_free(array, number);
      return r;
    }
  }

  *arrayp = array;

  array_num += number;

  return 0;
}

int array_free(array_t array, int number)
{
  int i;
  for (i = 0; i < number; i++) {
    if (array[i].value) {
      value_free(array[i].value);
      array[i].value = NULL;
    }
  }
  while ((array_num > 0) && !arrays[array_num - 1].value)
    array_num--;
  return 0;
}
