#ifndef __NLL_IMAGE_H_INCLUDED__
#define __NLL_IMAGE_H_INCLUDED__

typedef unsigned int image_draw_count_t;

typedef enum {
  IMAGE_STATUS_NONE = 0,
  IMAGE_STATUS_ACTIVE,
  IMAGE_STATUS_FREE,
} image_status_t;

typedef struct image {
  int width;
  int height;
  int size;
  int current_color;
  int *bitmap;
  volatile image_status_t status;
  struct image_draw {
    image_draw_count_t count;
    image_draw_count_t *line;
#define DRAW_COLUMN_PER 32
    int column_num;
    image_draw_count_t *column;
    image_draw_count_t *pixel;
  } draw;
} *image_t;

int image_is_draw_line(image_t image, image_draw_count_t count, int y);
int image_is_draw_column(image_t image, image_draw_count_t count, int x, int y);
int image_is_draw_pixel(image_t image, image_draw_count_t count, int x, int y);
int image_set_draw_line(image_t image, image_draw_count_t count, int y);
int image_set_draw_column(image_t image, image_draw_count_t count, int x, int y);
int image_set_draw_pixel(image_t image, image_draw_count_t count, int x, int y);
int image_get_color(image_t image, int x, int y);
int image_set_color(image_t image, int x, int y, int color, unsigned int flags);
int image_get_index(image_t image);
image_t image_get_image(int index);
int image_reset_draw(image_t image);
int image_done(image_t image);
int image_init(image_t image, int width, int height, int *bitmap);
image_t image_get(int width, int height, int *bitmap);

#endif
